%% PK plot
figure('units','normalized','outerposition',[0 0 1 1])

subplot(1,3,1)
hold on
set(gca,'xtick',0:6:24,'ytick',[0.1,1,10,100],'FontSize', 20,'FontSmoothing','on','fontname','Arial','YScale','log')
title('Pharmacokinetics')
line([0 0.5], [0.01 0.01],'Color','k','LineWidth',8);
plot(SubX1_data.time/60, SubX1_data.PKRat1,'.','Color',colorID{1},'MarkerSize',35)
plot(SubX1_data.time/60, SubX1_data.PKRat2,'.','Color',colorID{2},'MarkerSize',35)
plot(SubX1_data.time/60, SubX1_data.PKRat3,'.','Color',colorID{3},'MarkerSize',35)
plot(SubX1_data.time/60, SubX1_data.PKRat4,'.','Color',colorID{4},'MarkerSize',35)
plot(SubX1_data.time/60, SubX1_data.PKRat5,'.','Color',colorID{5},'MarkerSize',35)
plot(SubX1_data.time/60, SubX1_data.PKRat6,'.','Color',colorID{6},'MarkerSize',35)
plot(SubX1_data.time/60, SubX1_data.PKRat7,'.','Color',colorID{7},'MarkerSize',35)
plot(SubX1_data.time/60, SubX1_data.PKRat8,'.','Color',colorID{8},'MarkerSize',35)
plot(SubX1_data.time/60, SubX1_data.PKRat9,'.','Color',colorID{9},'MarkerSize',35)
plot(SubX1_data.time/60, SubX1_data.PKRat10,'.','Color',colorID{10},'MarkerSize',35)
ylabel({'SubX'; strcat('(',char(181),'Mol/L)')});
xlabel({'Time (h)'});
ylim( [0.01 200])
xlim( [0 25])
legend('Oral 80 uMol/kg','Rat 1','Rat 2','Rat 3','Rat 4','Rat 5','Rat 6','Rat 7','Rat 8','Rat 9','Rat 10')
grid on
hold off

% PK oral
subplot(1,3,2)
hold on
set(gca,'xtick',0:6:24,'ytick',0:50:250,'FontSize', 20,'FontSmoothing','on','fontname','Arial')
title('Hormone data')
line([0 0.5], [0 0],'Color','k','LineWidth',8);
plot(SubX1_data.time/60, SubX1_data.PDRat1,'.','Color',colorID{1},'MarkerSize',35)
plot(SubX1_data.time/60, SubX1_data.PDRat2,'.','Color',colorID{2},'MarkerSize',35)
plot(SubX1_data.time/60, SubX1_data.PDRat3,'.','Color',colorID{3},'MarkerSize',35)
plot(SubX1_data.time/60, SubX1_data.PDRat4,'.','Color',colorID{4},'MarkerSize',35)
plot(SubX1_data.time/60, SubX1_data.PDRat5,'.','Color',colorID{5},'MarkerSize',35)
plot(SubX1_data.time/60, SubX1_data.PDRat6,'.','Color',colorID{6},'MarkerSize',35)
plot(SubX1_data.time/60, SubX1_data.PDRat7,'.','Color',colorID{7},'MarkerSize',35)
plot(SubX1_data.time/60, SubX1_data.PDRat8,'.','Color',colorID{8},'MarkerSize',35)
plot(SubX1_data.time/60, SubX1_data.PDRat9,'.','Color',colorID{9},'MarkerSize',35)
plot(SubX1_data.time/60, SubX1_data.PDRat10,'.','Color',colorID{10},'MarkerSize',35)
ylabel({'SubX'; strcat('(',char(181),'Mol/L)')});
xlabel({'Time (h)'});
xlim( [0 25])
ylim( [0 250])
%legend('Oral 25 uMol','Rat 1','Rat 2','Rat 3','Rat 4','Rat 5','Rat 6','Rat 7','Rat 8','Rat 9','Rat 10')
grid on
hold off

% PD oral
subplot(1,3,3)
hold on
set(gca,'xtick',0:6:24,'ytick',0:25:125,'FontSize', 20,'FontSmoothing','on','fontname','Arial')
title('Normalised hormone data')
line([0 0.5], [0 0],'Color','k','LineWidth',8);
plot(SubX1_data.time/60, SubX1_data.NormPDRat1,'.','Color',colorID{1},'MarkerSize',35)
plot(SubX1_data.time/60, SubX1_data.NormPDRat2,'.','Color',colorID{2},'MarkerSize',35)
plot(SubX1_data.time/60, SubX1_data.NormPDRat3,'.','Color',colorID{3},'MarkerSize',35)
plot(SubX1_data.time/60, SubX1_data.NormPDRat4,'.','Color',colorID{4},'MarkerSize',35)
plot(SubX1_data.time/60, SubX1_data.NormPDRat5,'.','Color',colorID{5},'MarkerSize',35)
plot(SubX1_data.time/60, SubX1_data.NormPDRat6,'.','Color',colorID{6},'MarkerSize',35)
plot(SubX1_data.time/60, SubX1_data.NormPDRat7,'.','Color',colorID{7},'MarkerSize',35)
plot(SubX1_data.time/60, SubX1_data.NormPDRat8,'.','Color',colorID{8},'MarkerSize',35)
plot(SubX1_data.time/60, SubX1_data.NormPDRat9,'.','Color',colorID{9},'MarkerSize',35)
plot(SubX1_data.time/60, SubX1_data.NormPDRat10,'.','Color',colorID{10},'MarkerSize',35)
ylabel({'Relative baseline' ; '(%)'});
xlabel({'Time (h)'});
xlim( [0 25])
ylim( [0 125])
%legend('Oral 25 uMol','Rat 1','Rat 2','Rat 3','Rat 4','Rat 5','Rat 6','Rat 7','Rat 8','Rat 9','Rat 10')
grid on
hold off