function varargout  = SimulateRatExperiment(params,X,model,paramNames,stateNames,initialConditions,BWRats)
%params = exp(params);

global GroupID
if GroupID > 10
    GroupID = 1;
end

params(ismember(paramNames,"Rb")) = 0.75;       % Kleibers law
params(ismember(paramNames,"Vb")) = 1;    % Kleibers law
params(ismember(paramNames,"BW")) = BWRats(GroupID);    % Total body weight of the rats (kg)
params(ismember(paramNames,"f"))  = 0.62;    % Rat Bioavailability
params(ismember(paramNames,"ReAdministration_Time"))    = 1440*7;  % re-administration of drug is set to once every week, which will not be triggered in a 1 day long simulation
params(ismember(paramNames,"ReAdministration_Amount"))  = 0;       % if re-administration triggers then the state A is set to 0

initialConditions(ismember(stateNames,"A")) = 80*BWRats(GroupID); % Oral administration of subX (uMol)

try
simRatExperiment = model(0:60:1440,initialConditions,params); % Simulate Oral administration

SubX_RatExperiment.PK        = simRatExperiment.statevalues(:,ismember(simRatExperiment.states,'C1'));
SubX_RatExperiment.HormoneX  = simRatExperiment.statevalues(:,ismember(simRatExperiment.states,'HormoneX'));

varargout{1} = [SubX_RatExperiment.PK(2:end); SubX_RatExperiment.HormoneX];


catch error
varargout{1} = 1e50*ones(24+25,1);
end

if sum(params<0)> 0
  varargout{1} = 1e50*ones(24+25,1);  
end

GroupID = GroupID + 1;

end