X = []; Y =[]; GROUP =[];  % Creates the variables needed for input into NLME function

%% Declare model inputs

MonkeyBW = 4.31;
DogBW    = 9.725;
IndexBW  = [BWRats,MonkeyBW,DogBW];
IndexDose  = 80*IndexBW; % 80 umol/kg to umol
Bioavailability = [0.62,0.62,0.62,0.62,0.62,0.62,0.62,0.62,0.62,0.62,0.77,0.52];

%% Declare estimation data, groups, and amount of datapoints
Y = [Y;SubX1_data.PKRat1(2:25) ; SubX1_data.NormPDRat1(1:25)];
Y = [Y;SubX1_data.PKRat2(2:25) ; SubX1_data.NormPDRat2(1:25)];
Y = [Y;SubX1_data.PKRat3(2:25) ; SubX1_data.NormPDRat3(1:25)];
Y = [Y;SubX1_data.PKRat4(2:25) ; SubX1_data.NormPDRat4(1:25)];
Y = [Y;SubX1_data.PKRat5(2:25) ; SubX1_data.NormPDRat5(1:25)];
Y = [Y;SubX1_data.PKRat6(2:25) ; SubX1_data.NormPDRat6(1:25)];
Y = [Y;SubX1_data.PKRat7(2:25) ; SubX1_data.NormPDRat7(1:25)];
Y = [Y;SubX1_data.PKRat8(2:25) ; SubX1_data.NormPDRat8(1:25)];
Y = [Y;SubX1_data.PKRat9(2:25) ; SubX1_data.NormPDRat9(1:25)];
Y = [Y;SubX1_data.PKRat10(2:25); SubX1_data.NormPDRat10(1:25)];
Y = [Y;SubX1_data.Monkey(2:25) ; SubX1_data.NormPDMonkey(1:25)];
Y = [Y;SubX1_data.Dog(2:25)    ; SubX1_data.NormPDDog(1:25)];

for i=1:12
X     = [X    ;SubX1_data.time(2:25) ; SubX1_data.time(1:25)];
GROUP = [GROUP ; repmat(strcat("Animal" ,int2str(i)),24,1) ; repmat(strcat("Animal" ,int2str(i)),25,1)];
end

%% Optimisation options and settings

x0    = paramValues(1:10)';   % initial guess for the optimised parameters are declared as the values in the model.txt file
xform = eye(length(x0),1)';  % optimise all parameters on log scale

fun = @(phi,time)SimulateMetabolicScaling(phi,time,model,paramNames,stateNames,initialConditions,IndexBW,IndexDose,Bioavailability);

REParamsSelect = [3 5 7];
Cov0 = eye(length(REParamsSelect));

options             = statset;
options.Display     = 'iter';
options.FunValCheck = 'off' ;
 
[PHI,PSI,stats,b] = nlmefit(X,Y,GROUP,[],fun, x0,'OptimFun', 'fminunc','options',options,'REParamsSelect',REParamsSelect,'CovPattern',Cov0, 'ErrorModel','combined');

PHIR = repmat(PHI,1,12) + ...                % Fixed effects for 10 Rats + monkey + dog
      [zeros(1,12);zeros(1,12);b(1,:);zeros(1,12);b(2,:);zeros(1,12);b(3,:);zeros(1,12);zeros(1,12);zeros(1,12)];    % add random effects on fixed effects

OptimisedParams_Step2.PHIR = PHIR';
OptimisedParams_Step2.PHI  = PHI';
OptimisedParams_Step2.PSI  = PSI';
OptimisedParams_Step2.b    = b';

save(['OptimisedParams_Step2'],'OptimisedParams_Step2');

%%