%% PK plot
figure('units','normalized','outerposition',[0 0 1 1])

subplot(1,3,1)
hold on
set(gca,'xtick',0:6:24,'ytick',[0.1,1,10,100],'FontSize', 20,'FontSmoothing','on','fontname','Arial','YScale','log')
line([0 0.5], [0.01 0.01],'Color','k','LineWidth',8);
title('Rats')
plot(SubX1_data.time/60, SubX1_data.PKRat1,'.','Color',colorID{1},'MarkerSize',25)
plot(SubX1_data.time/60, SubX1_data.PKRat2,'.','Color',colorID{2},'MarkerSize',25)
plot(SubX1_data.time/60, SubX1_data.PKRat3,'.','Color',colorID{3},'MarkerSize',25)
plot(SubX1_data.time/60, SubX1_data.PKRat4,'.','Color',colorID{4},'MarkerSize',25)
plot(SubX1_data.time/60, SubX1_data.PKRat5,'.','Color',colorID{5},'MarkerSize',25)
plot(SubX1_data.time/60, SubX1_data.PKRat6,'.','Color',colorID{6},'MarkerSize',25)
plot(SubX1_data.time/60, SubX1_data.PKRat7,'.','Color',colorID{7},'MarkerSize',25)
plot(SubX1_data.time/60, SubX1_data.PKRat8,'.','Color',colorID{8},'MarkerSize',25)
plot(SubX1_data.time/60, SubX1_data.PKRat9,'.','Color',colorID{9},'MarkerSize',25)
plot(SubX1_data.time/60, SubX1_data.PKRat10,'.','Color',colorID{10},'MarkerSize',25)
ylabel({'SubX'; strcat('(',char(181),'Mol/L)')});
xlabel({'Time (h)'});
ylim( [0.01 500])
xlim( [0 25])
legend('Oral 80 uMol/kg')
grid on
hold off

subplot(1,3,2)
hold on
set(gca,'xtick',0:6:24,'ytick',[0.1,1,10,100],'FontSize', 20,'FontSmoothing','on','fontname','Arial','YScale','log')
title('Monkey')
line([0 0.5], [0.01 0.01],'Color','k','LineWidth',8);
plot(SubX1_data.time/60, SubX1_data.Monkey,'.','Color',colorID{11},'MarkerSize',25)
ylabel({'SubX'; strcat('(',char(181),'Mol/L)')});
xlabel({'Time (h)'});
ylim( [0.01 500])
xlim( [0 25])
legend('Oral 80 uMol/kg')
grid on
hold off

subplot(1,3,3)
hold on
set(gca,'xtick',0:6:24,'ytick',[0.1,1,10,100],'FontSize', 20,'FontSmoothing','on','fontname','Arial','YScale','log')
title('Dog')
line([0 0.5], [0.01 0.01],'Color','k','LineWidth',8);
plot(SubX1_data.time/60, SubX1_data.Dog,'.','Color',colorID{12},'MarkerSize',25)
ylabel({'SubX'; strcat('(',char(181),'Mol/L)')});
xlabel({'Time (h)'});
ylim( [0.01 500])
xlim( [0 25])
legend('Oral 80 uMol/kg')
grid on
hold off

%% Normalise Species

figure('units','normalized','outerposition',[0 0 1 1])

% Monkey
subplot(1,2,1)
hold on
set(gca,'xtick',0:6:24,'ytick',0:100:500,'FontSize', 20,'FontSmoothing','on','fontname','Arial')
title('Hormone Monkey data')
line([0 0.5], [0 0],'Color','k','LineWidth',8);
plot(SubX1_data.time/60, SubX1_data.PDMonkey,'.','Color',colorID{11},'MarkerSize',40)
plot(SubX1_data.time/60, SubX1_data.PDDog,'.','Color',colorID{12},'MarkerSize',40)
ylabel({'Hormone'; strcat('(',char(181),'Mol/L)')});
xlabel({'Time (h)'});
xlim( [0 25])
ylim( [0 500])
legend('Oral 80 uMol/kg','Monkey','Dog')
grid on
hold off

% Normalised
subplot(1,2,2)
hold on
set(gca,'xtick',0:6:24,'ytick',0:25:100,'FontSize', 20,'FontSmoothing','on','fontname','Arial')
title('Normalised Monkey data')
line([0 0.5], [0 0],'Color','k','LineWidth',8);
plot(SubX1_data.time/60, SubX1_data.NormPDMonkey,'.','Color',colorID{11},'MarkerSize',40)
plot(SubX1_data.time/60, SubX1_data.NormPDDog,'.','Color',colorID{12},'MarkerSize',40)
ylabel({'Relative baseline' ; '(%)'});
xlabel({'Time (h)'});
xlim( [0 25])
ylim( [0 125])
legend('Oral 80 uMol/kg','Monkey','Dog')
grid on
hold off

%%
figure('units','normalized','outerposition',[0 0 1 1])

% PD oral
subplot(1,3,1)
hold on
set(gca,'xtick',0:6:24,'ytick',0:25:125,'FontSize', 20,'FontSmoothing','on','fontname','Arial')
title('Normalised Rat data')
line([0 0.5], [0 0],'Color','k','LineWidth',8);
plot(SubX1_data.time/60, SubX1_data.NormPDRat1,'.','Color',colorID{1},'MarkerSize',20)
plot(SubX1_data.time/60, SubX1_data.NormPDRat2,'.','Color',colorID{2},'MarkerSize',20)
plot(SubX1_data.time/60, SubX1_data.NormPDRat3,'.','Color',colorID{3},'MarkerSize',20)
plot(SubX1_data.time/60, SubX1_data.NormPDRat4,'.','Color',colorID{4},'MarkerSize',20)
plot(SubX1_data.time/60, SubX1_data.NormPDRat5,'.','Color',colorID{5},'MarkerSize',20)
plot(SubX1_data.time/60, SubX1_data.NormPDRat6,'.','Color',colorID{6},'MarkerSize',20)
plot(SubX1_data.time/60, SubX1_data.NormPDRat7,'.','Color',colorID{7},'MarkerSize',20)
plot(SubX1_data.time/60, SubX1_data.NormPDRat8,'.','Color',colorID{8},'MarkerSize',20)
plot(SubX1_data.time/60, SubX1_data.NormPDRat9,'.','Color',colorID{9},'MarkerSize',20)
plot(SubX1_data.time/60, SubX1_data.NormPDRat10,'.','Color',colorID{10},'MarkerSize',20)
ylabel({'Relative baseline' ; '(%)'});
xlabel({'Time (h)'});
xlim( [0 25])
ylim( [0 125])
grid on
hold off
% PD oral
subplot(1,3,2)
hold on
set(gca,'xtick',0:6:24,'ytick',0:25:125,'FontSize', 20,'FontSmoothing','on','fontname','Arial')
title('Normalised Monkey data')
line([0 0.5], [0 0],'Color','k','LineWidth',8);
plot(SubX1_data.time/60, SubX1_data.NormPDMonkey,'.','Color',colorID{11},'MarkerSize',40)
ylabel({'Relative baseline' ; '(%)'});
xlabel({'Time (h)'});
xlim( [0 25])
ylim( [0 125])
grid on
hold off
% PD oral
subplot(1,3,3)
hold on
set(gca,'xtick',0:6:24,'ytick',0:25:125,'FontSize', 20,'FontSmoothing','on','fontname','Arial')
title('Normalised Dog data')
line([0 0.5], [0 0],'Color','k','LineWidth',8);
plot(SubX1_data.time/60, SubX1_data.NormPDDog,'.','Color',colorID{12},'MarkerSize',40)
ylabel({'Relative baseline' ; '(%)'});
xlabel({'Time (h)'});
xlim( [0 25])
ylim( [0 125])
grid on
hold off