function varargout  = SimulateMetabolicScaling(params,X,model,paramNames,stateNames,initialConditions,IndexBW,IndexDose,Bioavailability)
%params = exp(params);

global GroupID
if GroupID > 12
    GroupID = 1;
end

params(ismember(paramNames,"BW"))  = IndexBW(GroupID);
params(ismember(paramNames,"f"))   = Bioavailability(GroupID);
params(ismember(paramNames,"ReAdministration_Time"))    = 1440*7;  % re-administration of drug is set to once every week, which will not be triggered in a 1 day long simulation
params(ismember(paramNames,"ReAdministration_Amount"))  = 0;       % if re-administration triggers then the state A is set to 0

initialConditions(ismember(stateNames,"A")) = IndexDose(GroupID); % Oral administration of subX (uMol)

try
simMetabolicScaling = model(0:60:1440,initialConditions,params); % Simulate Oral administration

SubX_MetabolicScaling.PK        = simMetabolicScaling.statevalues(:,ismember(simMetabolicScaling.states,'C1'));
SubX_MetabolicScaling.HormoneX  = simMetabolicScaling.statevalues(:,ismember(simMetabolicScaling.states,'HormoneX'));

varargout{1} = [SubX_MetabolicScaling.PK(2:end); SubX_MetabolicScaling.HormoneX];

catch error
varargout{1} = 1e50*ones(24+25,1);
end

if sum(params<0)> 0
  varargout{1} = 1e50*ones(24+25,1);  
end

GroupID = GroupID + 1;

end